#include "function_type.hpp"

#include <eta/core/debug.hpp>
#include <unordered_map>

static std::unordered_map<std::string_view, FunctionType> const function_to_type = {
    { "STV_MPI_Send", FunctionType::MPI },
    { "STV_MPI_Isend", FunctionType::MPI },
    { "STV_MPI_Ibsend", FunctionType::MPI },
    { "STV_MPI_Issend", FunctionType::MPI },
    { "STV_MPI_Irsend", FunctionType::MPI },
    { "STV_MPI_Sendrecv", FunctionType::MPI },
    { "STV_MPI_Recv", FunctionType::MPI },
    { "STV_MPI_Irecv", FunctionType::MPI },
    { "STV_MPI_Wait", FunctionType::MPI },
    { "STV_MPI_Waitall", FunctionType::MPI },
    { "STV_MPI_Overlap", FunctionType::MPI },
    { "STV_MPI_Barrier", FunctionType::MPI },
    { "STV_MPI_BCast", FunctionType::MPI },
    { "STV_MPI_Gather", FunctionType::MPI },
    { "STV_MPI_Scatter", FunctionType::MPI },
    { "STV_MPI_Allgather", FunctionType::MPI },
    { "STV_MPI_Alltoall", FunctionType::MPI },
    { "STV_MPI_Reduce", FunctionType::MPI },
    { "STV_MPI_Allreduce", FunctionType::MPI },
    { "STV_MPI_reduce_scatter", FunctionType::MPI },
    { "STV_MPI_Scan", FunctionType::MPI },
    { "STV_MPI_Ibarrier", FunctionType::MPI },
    { "STV_MPI_Ibcast", FunctionType::MPI },
    { "STV_MPI_Igather", FunctionType::MPI },
    { "STV_MPI_Iscatter", FunctionType::MPI },
    { "STV_MPI_Iallgather", FunctionType::MPI },
    { "STV_MPI_Ialltoall", FunctionType::MPI },
    { "STV_MPI_Ireduce", FunctionType::MPI },
    { "STV_MPI_Iallreduce", FunctionType::MPI },
    { "STV_MPI_Ireduce_scatter", FunctionType::MPI },
    { "STV_MPI_Iscan", FunctionType::MPI },
    { "STV_MPI_Probe", FunctionType::MPI },
    { "MPI_Send", FunctionType::MPI },
    { "MPI_Isend", FunctionType::MPI },
    { "MPI_Ibsend", FunctionType::MPI },
    { "MPI_Issend", FunctionType::MPI },
    { "MPI_Irsend", FunctionType::MPI },
    { "MPI_Sendrecv", FunctionType::MPI },
    { "MPI_Recv", FunctionType::MPI },
    { "MPI_Irecv", FunctionType::MPI },
    { "MPI_Wait", FunctionType::MPI },
    { "MPI_Waitall", FunctionType::MPI },
    { "MPI_Overlap", FunctionType::MPI },
    { "MPI_Barrier", FunctionType::MPI },
    { "MPI_BCast", FunctionType::MPI },
    { "MPI_Gather", FunctionType::MPI },
    { "MPI_Scatter", FunctionType::MPI },
    { "MPI_Allgather", FunctionType::MPI },
    { "MPI_Alltoall", FunctionType::MPI },
    { "MPI_Reduce", FunctionType::MPI },
    { "MPI_Allreduce", FunctionType::MPI },
    { "MPI_reduce_scatter", FunctionType::MPI },
    { "MPI_Scan", FunctionType::MPI },
    { "MPI_Ibarrier", FunctionType::MPI },
    { "MPI_Ibcast", FunctionType::MPI },
    { "MPI_Igather", FunctionType::MPI },
    { "MPI_Iscatter", FunctionType::MPI },
    { "MPI_Iallgather", FunctionType::MPI },
    { "MPI_Ialltoall", FunctionType::MPI },
    { "MPI_Ireduce", FunctionType::MPI },
    { "MPI_Iallreduce", FunctionType::MPI },
    { "MPI_Ireduce_scatter", FunctionType::MPI },
    { "MPI_Iscan", FunctionType::MPI },
    { "MPI_Probe", FunctionType::MPI },
    { "MPI_Comm_dup", FunctionType::MPI },
    { "MPI_Comm_split", FunctionType::MPI },
    { "mpi_send_", FunctionType::MPI },
    { "mpi_isend_", FunctionType::MPI },
    { "mpi_ibsend_", FunctionType::MPI },
    { "mpi_issend_", FunctionType::MPI },
    { "mpi_irsend_", FunctionType::MPI },
    { "mpi_sendrecv_", FunctionType::MPI },
    { "mpi_recv_", FunctionType::MPI },
    { "mpi_irecv_", FunctionType::MPI },
    { "mpi_wait_", FunctionType::MPI },
    { "mpi_waitall_", FunctionType::MPI },
    { "mpi_overlap_", FunctionType::MPI },
    { "mpi_barrier_", FunctionType::MPI },
    { "mpi_bcast_", FunctionType::MPI },
    { "mpi_gather_", FunctionType::MPI },
    { "mpi_scatter_", FunctionType::MPI },
    { "mpi_allgather_", FunctionType::MPI },
    { "mpi_alltoall_", FunctionType::MPI },
    { "mpi_reduce_", FunctionType::MPI },
    { "mpi_allreduce_", FunctionType::MPI },
    { "mpi_reduce_scatter_", FunctionType::MPI },
    { "mpi_scan_", FunctionType::MPI },
    { "mpi_ibarrier_", FunctionType::MPI },
    { "mpi_ibcast_", FunctionType::MPI },
    { "mpi_igather_", FunctionType::MPI },
    { "mpi_iscatter_", FunctionType::MPI },
    { "mpi_iallgather_", FunctionType::MPI },
    { "mpi_ialltoall_", FunctionType::MPI },
    { "mpi_ireduce_", FunctionType::MPI },
    { "mpi_iallreduce_", FunctionType::MPI },
    { "mpi_ireduce_scatter_", FunctionType::MPI },
    { "mpi_iscan_", FunctionType::MPI },
    { "mpi_probe_", FunctionType::MPI },

    { "GOMP_Section_State", FunctionType::OMP },
    { "GOMP_Critical", FunctionType::OMP },
    { "GOMP_Atomic", FunctionType::OMP },
    { "GOMP_For", FunctionType::OMP },
    { "GOMP_Master", FunctionType::OMP },
    { "STV_GOMP_Lock", FunctionType::OMP },
    { "STV_GOMP_Locked", FunctionType::OMP },
    { "STV_GOMP_NLock", FunctionType::OMP },
    { "STV_GOMP_NLocked", FunctionType::OMP },
    { "GOMP_TaskWait", FunctionType::OMP },
    { "GOMP_Task", FunctionType::OMP },
    { "GOMP_Untied_Task", FunctionType::OMP },
    { "GOMP_Task_Create", FunctionType::OMP },
    { "GOMP_Untied_Task_Create", FunctionType::OMP },
    { "GOMP_Barrier", FunctionType::OMP_SYNC },
    { "GOMP_Implicit_Barrier", FunctionType::OMP_SYNC },

    { "stdio_read", FunctionType::STDIO },
    { "stdio_pread", FunctionType::STDIO },
    { "stdio_readv", FunctionType::STDIO },
    { "stdio_fread", FunctionType::STDIO },
    { "stdio_write", FunctionType::STDIO },
    { "stdio_pwrite", FunctionType::STDIO },
    { "stdio_writev", FunctionType::STDIO },
    { "stdio_fwrite", FunctionType::STDIO },
    { "stdio_select", FunctionType::STDIO },
    { "stdio_pselect", FunctionType::STDIO },
    { "stdio_lseek", FunctionType::STDIO },
    { "stdio_poll", FunctionType::STDIO },
    { "stdio_ppoll", FunctionType::STDIO },

    { "STV_Blocked_sem", FunctionType::PTHREAD },
    { "STV_Blocked_spin", FunctionType::PTHREAD },
    { "STV_Blocked_mutex", FunctionType::PTHREAD },
    { "STV_Blocked_condition", FunctionType::PTHREAD },
    { "STV_Blocked_cond", FunctionType::PTHREAD },
    { "STV_Blocked_rwlock", FunctionType::PTHREAD },
    { "STV_Blocked_barrier", FunctionType::PTHREAD },
    { "STV_Critical_sem", FunctionType::PTHREAD },
    { "STV_Critical_spin", FunctionType::PTHREAD },
    { "STV_Critical_mutex", FunctionType::PTHREAD },
    { "STV_Critical_condition", FunctionType::PTHREAD },
    { "STV_Critical_rwlock", FunctionType::PTHREAD },
};

auto get_function_type(std::string_view str) -> FunctionType {
    auto const it = function_to_type.find(str);
    if (it == function_to_type.end())
        return FunctionType::UNKNOWN;
    return it->second;
}

auto to_string(FunctionType f) -> std::string_view {
    switch (f) {
        case FunctionType::MPI: return "MPI";
        case FunctionType::OMP: return "OpenMP";
        case FunctionType::OMP_SYNC: return "OpenMP Sync";
        case FunctionType::STDIO: return "stdio";
        case FunctionType::PTHREAD: return "pthread";
        case FunctionType::OTHER: return "Other";
        default:
            Assert(false,
                   "Unknown function type {}",
                   static_cast<typename std::underlying_type<FunctionType>::type>(f));
            return "";
    }
}

